Codeforces Round #367 (Div. 2) C. Hard problem(DP)

Hard problem

题目链接:

http://codeforces.com/contest/706/problem/C

Description

``` Vasiliy is fond of solving different tasks. Today he found one he wasn't able to solve himself, so he asks you to help.

Vasiliy is given n strings consisting of lowercase English letters. He wants them to be sorted in lexicographical order (as in the dictionary), but he is not allowed to swap any of them. The only operation he is allowed to do is to reverse any of them (first character becomes last, second becomes one before last and so on).

To reverse the i-th string Vasiliy has to spent ci units of energy. He is interested in the minimum amount of energy he has to spent in order to have strings sorted in lexicographical order.

String A is lexicographically smaller than string B if it is shorter than B (|A| < |B|) and is its prefix, or if none of them is a prefix of the other and at the first position where they differ character in A is smaller than the character in B.

For the purpose of this problem, two equal strings nearby do not break the condition of sequence being sorted lexicographically.

</big>


 




##Input
<big>

The first line of the input contains a single integer n (2 ≤ n ≤ 100 000) — the number of strings.

The second line contains n integers ci (0 ≤ ci ≤ 109), the i-th of them is equal to the amount of energy Vasiliy has to spent in order to reverse the i-th string.

Then follow n lines, each containing a string consisting of lowercase English letters. The total length of these strings doesn't exceed 100 000.

</big>






##Output
<big>

If it is impossible to reverse some of the strings such that they will be located in lexicographical order, print  - 1. Otherwise, print the minimum total amount of energy Vasiliy has to spent.

</big>


 
 
##Examples
<big>
input
2
1 2
ba
ac
output
1
input
3
1 3 1
aa
ba
ac
output
1
input
2
5 5
bbb
aaa
output
-1
input
2
3 3
aaa
aa
output
-1
</big>


##Source
<big>
Codeforces Round #367 (Div. 2)
</big>




<br/>
##题意:
<big>
给出若干个字符串,反转一个字符串有对应的花费. 
求最小花费使得字符串按字典升序.
</big>


<br/>
##题解:
<big>
因为每个字符串要么反转要么不翻转. 所以直接用dp来做:
dp[i][0]:第i个字符串不反转且使得前i个串升序的最小代价.
dp[i][1]:第i个字符串反转且使得前i个串升序的最小代价.
这里先预处理出每个串的反转,每次要先比较能否保持升序再作更新.
</big>




<br/>
##代码:
``` cpp
#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <vector>
#include <list>
#define LL long long
#define eps 1e-8
#define maxn 101000
#define mod 100000007
#define inf 0x3f3f3f3f3f3f3f3f
#define mid(a,b) ((a+b)>>1)
#define IN freopen("in.txt","r",stdin);
using namespace std;

int n;
string str[maxn];
string rev[maxn];
LL cost[maxn];
LL dp[maxn][2];

int main(int argc, char const *argv[])
{
    //IN;

    while(scanf("%d", &n) != EOF)
    {
        for(int i=1; i<=n; i++) {
            cin >> cost[i];
        }
        for(int i=1; i<=n; i++) {
            cin >> str[i];
            rev[i] = str[i];
            reverse(rev[i].begin(), rev[i].end());
        }

        dp[1][0] = 0;
        dp[1][1] = cost[1];
        for(int i=2; i<=n; i++) {
            dp[i][0] = dp[i][1] = inf;
            if(str[i] >= str[i-1]) {
                dp[i][0] = min(dp[i][0], dp[i-1][0]);
            }
            if(str[i] >= rev[i-1]) {
                dp[i][0] = min(dp[i][0], dp[i-1][1]);
            }

            if(rev[i] >= str[i-1]) {
                dp[i][1] = min(dp[i][1], dp[i-1][0]+cost[i]);
            }
            if(rev[i] >= rev[i-1]) {
                dp[i][1] = min(dp[i][1], dp[i-1][1]+cost[i]);
            }
        }

        if(dp[n][0] == inf && dp[n][1] == inf) printf("-1
");
        else printf("%I64d
", min(dp[n][0],dp[n][1]));
    }

    return 0;
}
原文地址:https://www.cnblogs.com/Sunshine-tcf/p/5793582.html